#!/bin/bash
# 
# Wizard
#
# Copyright (C) 2000 Mandrakesoft.
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# See file LICENSE for further informations on licensing terms.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
# 
# Authors: Jerome Dumonteil, Maurizio De Cecco, Enzo Maggi
# icons: Helene Durosini <ln@mandrakesoft.com>
# <corporate@mandrakesoft.com> http://www.mandrakesoft.com

echo_debug "in $0"

wiz_ip_net=`get_var wiz_ip_net`
wiz_ip_server=`get_var wiz_ip_server`
wiz_domain_name=`get_var wiz_domain_name`
s_trunc=${wiz_ip_net%.*}
ds=${wiz_ip_server##*.}
sc_trunc=${wiz_client_ip%.*}
dc=${wiz_client_ip##*.}

wiz_client_name=${wiz_client_name%%.*}

# change serial number
# $1 : file
up_serial(){
TMPFILE=`mktemp /tmp/temp.XXXXXX` || exit 1
cat $1 > ${TMPFILE}
serial_nbm=$(date "+%Y%m%d00")
serial_f=`sed -ne "s/^\([[:space:]]*\)\([0-9]*\)\([[:space:]]*;[[:space:]]*Serial.*$\)/\2/p" ${TMPFILE}`
serial_f=$((${serial_f}+1))
if [ ${serial_f} -le ${serial_nbm} ]; then
	serial_f=${serial_nbm}
fi

cat ${TMPFILE}\
|sed -e "s/^\([[:space:]]*\)\([0-9]*\)\([[:space:]]*;[[:space:]]*Serial.*$\)/\1${serial_f}\3/"\
> $1
rm -f ${TMPFILE}
}



file="/var/named/${wiz_domain_name}.db"

bck_file ${file}

echo "${wiz_client_name}        IN A  ${wiz_client_ip}  ; $(date)" >> ${file}

up_serial ${file}



file="/var/named/${s_trunc}.rev"

bck_file ${file}

echo "${dc}        IN PTR  ${wiz_client_name}.  ; $(date)" >> ${file}

up_serial ${file}


/etc/rc.d/init.d/named restart

# all seems to be ok
exit 10
