#!/bin/bash
# 
# Wizard
#
# Copyright (C) 2000 Mandrakesoft.
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# See file LICENSE for further informations on licensing terms.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
# 
# Authors: Jerome Dumonteil, Maurizio De Cecco, Enzo Maggi
# icons: Helene Durosini <ln@mandrakesoft.com>
# <corporate@mandrakesoft.com> http://www.mandrakesoft.com

echo_debug "in $0"

wiz_ip_net=`get_var wiz_ip_net`
wiz_ip_server=`get_var wiz_ip_server`
wiz_domain_name=`get_var wiz_domain_name`
s_trunc=${wiz_ip_net%.*}
ds=${wiz_ip_server##*.}
sc_trunc=${wiz_client_ip%.*}
dc=${wiz_client_ip##*.}

wiz_client_name=${wiz_client_name%%.*}

if [ -z "${wiz_client_name}" ]; then
	echo_debug "incorrect name"
	exit 1
fi

if [ -z "${wiz_client_ip}" ]; then
	echo_debug "incorrect address"
	exit 1
fi

if [ -z "${sc_trunc}" ]; then
	echo_debug "incorrect address"
	exit 1
fi
if [ -z "${dc}" ]; then
	echo_debug "incorrect address"
	exit 1
fi

if [ "${s_trunc}" != "${sc_trunc}" ]; then
	echo_debug "range not in network"
	exit 1
fi

if [ "${dc}" = "${ds}" -o ${dc} -le 0 -o ${dc} -gt 255 ]; then
	echo_debug "bad ip"
	exit 1
fi


file="/var/named/${wiz_domain_name}.db"
t=`grep -E "^${wiz_client_name}[[:space:]]*IN" ${file}`
if [ -n "$t" ]; then
	echo_debug "${wiz_client_name} got in ${file}"
	exit 2
fi
t=`grep -E "^[^;]*A[[:space:]]*${wiz_client_ip}" ${file}`
if [ -n "$t" ]; then
	echo_debug "${wiz_client_ip} got in ${file}"
	exit 2
fi

file="/var/named/${s_trunc}.rev"
t=`grep -E "^${dc}[[:space:]]*IN" ${file}`
if [ -n "$t" ]; then
	echo_debug "${dc} got in ${file}"
	exit 2
fi
t=`grep -E "^[^;]*PTR[[:space:]]*${wiz_client_name}" ${file}`
if [ -n "$t" ]; then
	echo_debug "${wiz_client_name} got in ${file}"
	exit 2
fi

# all seems to be ok
exit 10
