#!/bin/bash
# 
# Wizard
#
# Copyright (C) 2000 Mandrakesoft.
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# See file LICENSE for further informations on licensing terms.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
# 
# Authors: Jerome Dumonteil, Maurizio De Cecco, Enzo Maggi
# icons: Helene Durosini <ln@mandrakesoft.com>
# <corporate@mandrakesoft.com> http://www.mandrakesoft.com

# script for wizard configuration
# 
# $1, $2, ... : root wiz_ip_net wiz_...
#
# exit 0 if all is ok, else exit nb , where nb is the arg number that fails

typeset -i cpt
cpt=0

for test in $@ ; do
  
  cpt=$cpt+1
  
  case "$test" in
  
  root)
	if [ ! -z "${_WIZ_DO_AS_ROOT}" ]; then
		echo_debug "Emulating Root login , no problem"		
	else
	   if [ `id|sed 's/^uid=\([0-9]*\)[^0-9]*.*$/\1/'` -ne 0 ]; then
	        echo_debug "need to be root, exit $cpt"
		exit $cpt
	   fi
        fi
	;;
  *)
  	ret=`get_var ${test}`
	if [ -z "$ret" ]; then
		echo_debug "no value for $test , exit $cpt"
		exit $cpt
	fi
  	;;
 esac
 
done

# all seems to be ok
exit 0

