#!/bin/bash
# 
# Wizard
#
# Copyright (C) 2000 Mandrakesoft.
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# See file LICENSE for further informations on licensing terms.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
# 
# Authors: Jerome Dumonteil, Maurizio De Cecco, Enzo Maggi
# icons: Helene Durosini <ln@mandrakesoft.com>
# <corporate@mandrakesoft.com> http://www.mandrakesoft.com

# script for wizard leafnode configuration
#
# put the default leafnode configuration
# assuming all dependencies are ok


# wiz_news_server and wiz_news_freq are provided by the running wizard

# security
typeset -i freq
freq=`echo ${wiz_news_freq} |sed -e 's/[^0-9]//g'`

if [ $freq -le 0 ]; then
    freq=1
fi
if [ $freq -ge 24 ]; then
    freq=24
fi


server=`echo ${wiz_news_server##*@} |sed -e 's/[^0-9a-zA-Z-\.]//g'`

# store the wiz_news_server and wiz_news_freq value
file=/etc/sysconfig/mdk_serv
chg_val ${file} wiz_news_freq ${freq} s
chg_val ${file} wiz_news_server ${server} s


# leafnode configuration file
config="/etc/leafnode/config"
if [ ! -f ${config} ]; then
	echo_debug "no leafnode configuration file found ! exiting."
	exit 1
fi

bck_file ${config}

cat ${CWD}/scripts/config.default \
| sed -e 's/__server__/'"${server}"'/' > ${config}

echo_debug "config file done, putting crontab for news"

if [ -f /var/spool/cron/news ]; then
	cp -f /var/spool/cron/news /etc/leafnode/crontab
fi

bck_file /etc/leafnode/crontab

cat ${CWD}/scripts/news.cron \
| sed -e 's/__freq__/'"${freq}"'/' > /etc/leafnode/crontab


echo_debug "installing news crontab"
crontab -u news /etc/leafnode/crontab


# all is ok
exit 10



