#!/usr/bin/perl

# Drakwizard

# Copyright (C) 2002 MandrakeSoft Arnaud Desmons (adesmons@mandrakesoft.com)
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

package NFSConf;
use lib "/usr/lib/libDrakX";
require "/usr/share/wizards/common/scripts/Vareqval.pm";
require "/usr/share/wizards/common/scripts/IFCFG.pm";
use MDK::Common;
use services;
use strict;

my $o = IFCFG->new();

sub	network_mask {
    my $wiz_ip_server = $o->itf_get("IPADDR");
    my $mask = $o->itf_get("NETMASK");
    $mask = $mask ? $mask : "255.255.255.0";
    $wiz_ip_server = $wiz_ip_server ? $wiz_ip_server : "192.168.1.0";
    "$1.$2.$3.0/$mask" if $wiz_ip_server =~ /(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})/;
}

sub	chooser {
    $ENV{wiz_nfs_level};
}

sub	do_it {
    my $line;
    my $file = "/etc/exports";
    chomp($ENV{wiz_nfs_dir});
    -f $file and cp_af($file, $file.".orig");
    if ($ENV{wiz_nfs_level} == 2) {
	my $mask = $o->itf_get("NETMASK");
	$line = "$ENV{wiz_nfs_dir} $ENV{wiz_netmask}(rw,no_root_squash)\n";
    }
    else {
	$line = "$ENV{wiz_nfs_dir} *(rw,no_root_squash)\n";
    }
    my $t;
    foreach (cat_($file)) {
	if (/^(?!\#).*$ENV{wiz_nfs_dir}\s.*/) {
	    $t = $_;
	    last;
	}
    }
    substInFile { s|^(?!\#).*$ENV{wiz_nfs_dir}\s.*|\#$&|} $file;
    append_to_file($file, $line);
    system("/usr/sbin/exportfs -a");
    services::is_service_running('nfs') and services::start('nfs');
    10
}
